\documentclass[twoside]{book}

% Packages required by doxygen
\usepackage{calc}
\usepackage{doxygen}
\usepackage{graphicx}
\usepackage[utf8]{inputenc}
\usepackage{makeidx}
\usepackage{multicol}
\usepackage{multirow}
\usepackage{fixltx2e}
\PassOptionsToPackage{warn}{textcomp}
\usepackage{textcomp}
\usepackage[nointegrals]{wasysym}
\usepackage[table]{xcolor}

% Font selection
\usepackage[T1]{fontenc}
\usepackage{mathptmx}
\usepackage[scaled=.90]{helvet}
\usepackage{courier}
\usepackage{amssymb}
\usepackage{sectsty}
\renewcommand{\familydefault}{\sfdefault}
\allsectionsfont{%
  \fontseries{bc}\selectfont%
  \color{darkgray}%
}
\renewcommand{\DoxyLabelFont}{%
  \fontseries{bc}\selectfont%
  \color{darkgray}%
}
\newcommand{\+}{\discretionary{\mbox{\scriptsize$\hookleftarrow$}}{}{}}

% Page & text layout
\usepackage{geometry}
\geometry{%
  a4paper,%
  top=2.5cm,%
  bottom=2.5cm,%
  left=2.5cm,%
  right=2.5cm%
}
\tolerance=750
\hfuzz=15pt
\hbadness=750
\setlength{\emergencystretch}{15pt}
\setlength{\parindent}{0cm}
\setlength{\parskip}{0.2cm}
\makeatletter
\renewcommand{\paragraph}{%
  \@startsection{paragraph}{4}{0ex}{-1.0ex}{1.0ex}{%
    \normalfont\normalsize\bfseries\SS@parafont%
  }%
}
\renewcommand{\subparagraph}{%
  \@startsection{subparagraph}{5}{0ex}{-1.0ex}{1.0ex}{%
    \normalfont\normalsize\bfseries\SS@subparafont%
  }%
}
\makeatother

% Headers & footers
\usepackage{fancyhdr}
\pagestyle{fancyplain}
\fancyhead[LE]{\fancyplain{}{\bfseries\thepage}}
\fancyhead[CE]{\fancyplain{}{}}
\fancyhead[RE]{\fancyplain{}{\bfseries\leftmark}}
\fancyhead[LO]{\fancyplain{}{\bfseries\rightmark}}
\fancyhead[CO]{\fancyplain{}{}}
\fancyhead[RO]{\fancyplain{}{\bfseries\thepage}}
\fancyfoot[LE]{\fancyplain{}{}}
\fancyfoot[CE]{\fancyplain{}{}}
\fancyfoot[RE]{\fancyplain{}{\bfseries\scriptsize Generated on Thu Jun 25 2015 11\+:13\+:59 for T\+I  Graph Library   (\+T\+I\+G\+L) by Doxygen }}
\fancyfoot[LO]{\fancyplain{}{\bfseries\scriptsize Generated on Thu Jun 25 2015 11\+:13\+:59 for T\+I  Graph Library   (\+T\+I\+G\+L) by Doxygen }}
\fancyfoot[CO]{\fancyplain{}{}}
\fancyfoot[RO]{\fancyplain{}{}}
\renewcommand{\footrulewidth}{0.4pt}
\renewcommand{\chaptermark}[1]{%
  \markboth{#1}{}%
}
\renewcommand{\sectionmark}[1]{%
  \markright{\thesection\ #1}%
}

% Indices & bibliography
\usepackage{natbib}
\usepackage[titles]{tocloft}
\setcounter{tocdepth}{3}
\setcounter{secnumdepth}{5}
\makeindex

% Hyperlinks (required, but should be loaded last)
\usepackage{ifpdf}
\ifpdf
  \usepackage[pdftex,pagebackref=true]{hyperref}
\else
  \usepackage[ps2pdf,pagebackref=true]{hyperref}
\fi
\hypersetup{%
  colorlinks=true,%
  linkcolor=blue,%
  citecolor=blue,%
  unicode%
}

% Custom commands
\newcommand{\clearemptydoublepage}{%
  \newpage{\pagestyle{empty}\cleardoublepage}%
}


%===== C O N T E N T S =====

\begin{document}

% Titlepage & ToC
\hypersetup{pageanchor=false,
             bookmarks=true,
             bookmarksnumbered=true,
             pdfencoding=unicode
            }
\pagenumbering{roman}
\begin{titlepage}
\vspace*{7cm}
\begin{center}%
{\Large T\+I Graph Library (T\+I\+G\+L) \\[1ex]\large ver1.\+00.\+00 }\\
\vspace*{1cm}
{\large Generated by Doxygen 1.8.7}\\
\vspace*{0.5cm}
{\small Thu Jun 25 2015 11:13:59}\\
\end{center}
\end{titlepage}
\clearemptydoublepage
\tableofcontents
\clearemptydoublepage
\pagenumbering{arabic}
\hypersetup{pageanchor=true}

%--- Begin generated contents ---
\chapter{Introduction}
\label{index}\hypertarget{index}{}\input{index}
\chapter{Module Index}
\input{modules}
\chapter{Hierarchical Index}
\input{hierarchy}
\chapter{Class Index}
\input{annotated}
\chapter{File Index}
\input{files}
\chapter{Module Documentation}
\input{group__graphGenertor}
\include{group__pageRank}
\include{group__SSSP}
\include{group__comm__routines}
\include{group__comm__engine}
\include{group__messages}
\include{group__containers}
\include{group__core}
\include{group__gen__test}
\include{group__mutation__test__1D}
\include{group__mutation__test__mpi}
\include{group__interface__engine}
\include{group__data__structures}
\include{group__comp__engine}
\include{group__comm__module}
\include{group__mutation__engine}
\include{group__appGroup}
\include{group__file__io}
\include{group__misc__tools}
\include{group__graph__gen}
\include{group__tests}
\chapter{Class Documentation}
\input{classPageRankCombiner}
\input{classPageRankVertex}
\input{classPageRankVertexSeq}
\input{classSSSPCombiner}
\input{classSSSPInfo}
\input{structSSSPNodeSeq}
\input{classSSSPVertex}
\input{classSSSPVertexSeq}
\input{classTIGL}
\input{classTIGLApiCombiner}
\input{classTIGLApiMessage}
\input{classTIGLApiTester}
\input{classTIGLApiVertex}
\input{classTIGLCommunicationAggregateSysMessage}
\input{classTIGLCommunicationManager}
\input{structTIGLCommunicationMessageDev}
\input{classTIGLCommunicationSysMessage}
\input{classTIGLComputationManager}
\input{classTIGLContainersAggregate}
\input{classTIGLContainersBiVertex}
\input{classTIGLContainersBiVertexBase}
\input{classTIGLContainersComputeEdge}
\input{classTIGLContainersEdge2Sided}
\input{classTIGLContainersEdgeBase}
\input{classTIGLContainersEdgeW}
\input{classTIGLContainersEdgeW2Sided}
\input{structTIGLContainersGraphTraits}
\input{classTIGLContainersPosInfo}
\input{classTIGLContainersSubgraph}
\input{classTIGLContainersSubgraphBase}
\input{classTIGLContainersVertexBase}
\input{structTIGLContainersVertexTraits}
\input{classTIGLMutationManager}
\input{classTIGLMutationMessage}
\chapter{File Documentation}
\input{appGenerateGraph_8cpp}
\input{appPageRank_8cpp}
\input{appPageRank_8hpp}
\input{appPageRankSequential_8hpp}
\input{appPageRankVertexSequential_8hpp}
\input{appSSSP_8cpp}
\input{appSSSP_8hpp}
\input{appSSSPSequential_8hpp}
\input{appSSSPVertexSequential_8hpp}
\input{testGeneration_8cpp}
\input{testMutationManager1D_8cpp}
\input{testMutationManagerMpi_8cpp}
\input{tigl_8hpp}
\input{tiglApiCombiner_8hpp}
\input{tiglApiMessage_8hpp}
\input{tiglApiTester_8hpp}
\input{tiglApiVertex_8hpp}
\input{tiglCommunication_8hpp}
\input{tiglCommunicationAggregateSysMessage_8hpp}
\input{tiglCommunicationFindDev_8cpp}
\input{tiglCommunicationManager_8hpp}
\input{tiglCommunicationManagerImplementation_8hpp}
\input{tiglCommunicationMonitor_8cpp}
\input{tiglCommunicationRx_8cpp}
\input{tiglCommunicationSysMessage_8hpp}
\input{tiglCommunicationTx_8cpp}
\input{tiglComputationManager_8hpp}
\input{tiglComputationManagerImplementation_8hpp}
\input{tiglContainersAggregate_8hpp}
\input{tiglContainersBivertex_8hpp}
\input{tiglContainersBiVertexBase_8hpp}
\input{tiglContainersComputeEdge_8hpp}
\input{tiglContainersEdge2Sided_8hpp}
\input{tiglContainersEdgeBase_8hpp}
\input{tiglContainersEdgeW_8hpp}
\input{tiglContainersEdgeW2Sided_8hpp}
\input{tiglContainersGraphTraits_8hpp}
\input{tiglContainersSubgraph_8hpp}
\input{tiglContainersSubgraphBase_8hpp}
\input{tiglContainersSubgraphBaseImplementation_8hpp}
\input{tiglContainersSubgraphImplementation_8hpp}
\input{tiglContainersVertexBase_8hpp}
\input{tiglContainersVertexTraits_8hpp}
\input{tiglGenerationConstructGraphRmat_8hpp}
\input{tiglGenerationGenerateEdgeList_8hpp}
\input{tiglGenerationPartitionGraph_8cpp}
\input{tiglGenerationRemoveSelfCycles_8hpp}
\input{tiglImplementation_8hpp}
\input{tiglImplementationCombiner_8hpp}
\input{tiglImplementationMessage_8hpp}
\input{tiglImplementationTester_8hpp}
\input{tiglImplementationVertex_8hpp}
\input{tiglMutationManager_8hpp}
\input{tiglMutationMessage_8hpp}
\input{tiglMutationMessageImplementation_8hpp}
\input{tiglRW_8hpp}
\input{tiglRWReadAdjList_8hpp}
\input{tiglRWReadDataFile_8hpp}
\input{tiglRWWriteAdjList_8hpp}
\input{tiglRWWriteAlgData_8hpp}
\input{tiglUtils_8hpp}
\input{tiglUtilsAvailableMemory_8cpp}
\input{tiglUtilsCheckSymmetry_8hpp}
\input{tiglUtilsCountEdges_8hpp}
\input{tiglUtilsGenUrandom_8cpp}
\input{tiglUtilsGetTimeUs_8cpp}
\input{tiglUtilsMacros_8h}
\input{tiglUtilsMpiBarrier_8cpp}
\input{tiglUtilsMpiTools_8h}
\input{tiglUtilsOmpTools_8cpp}
\input{tiglUtilsOmpTools_8h}
\input{tiglUtilsRegisterTime_8cpp}
%--- End generated contents ---

% Bibliography
\newpage
\phantomsection
\addcontentsline{toc}{chapter}{Bibliography}
\bibliographystyle{plain}
\bibliography{tigl}

% Index
\newpage
\phantomsection
\addcontentsline{toc}{chapter}{Index}
\printindex

\end{document}
